## ttdnsd-0.7.tar.gz

=== Makefile ===
TTDNSDVERSION= 0.7
GPGKEYID=E012B42D
EXEC = ttdnsd
CC = /usr/bin/gcc
CHROOT = /var/lib/ttdnsd
PIDFILE = $(CHROOT)/pid
CONF = ttdnsd.conf
TORTSOCKSCONF = tor-tsocks.conf
MANPAGE = ttdnsd.1
INITSCRIPT = ttdnsd.init
TSOCKSLIB = tsocks
# If the program ever grows, we'll enjoy this macro:
SRCFILES := $(wildcard *.c)
OBJFILES := $(patsubst %.c,%.o,$(wildcard *.c))
SUDO = sudo

# Build host specific additionals.  Uncomment whatever matches your situation.
# For BSD's with pkgsrc:
#EXTRA_CFLAGS = -I /usr/pkg/include -L /usr/pkg/lib

# Hardening and warnings for building with gcc
GCCWARNINGS = -Wall -fno-strict-aliasing -W -Wfloat-equal -Wundef	\
-Wpointer-arith -Wstrict-prototypes -Wmissing-prototypes		\
-Wwrite-strings -Wredundant-decls -Wchar-subscripts -Wcomment		\
-Wformat=2 -Wwrite-strings -Wmissing-declarations -Wredundant-decls	\
-Wnested-externs -Wbad-function-cast -Wswitch-enum -Winit-self		\
-Wmissing-field-initializers -Wdeclaration-after-statement		\
-Wold-style-definition -Waddress -Wmissing-noreturn -Wnormalized=id	\
-Woverride-init -Wstrict-overflow=1 -Wextra -Warray-bounds		\
-Wstack-protector -Wformat -Wformat-security -Wpointer-sign
GCCHARDENING=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fwrapv -fPIE --param ssp-buffer-size=1
LDHARDENING=-pie -z relro -z now

CFLAGS=-g -O2 $(EXTRA_CFLAGS) $(GCCHARDENING) $(GCCWARNINGS) -Werror
LDFLAGS= $(LDHARDENING)

all: $(SRCFILES)
	$(CC) $(CFLAGS) $(SRCFILES) -o $(EXEC) -l$(TSOCKSLIB) -L$(STAGING_DIR)/usr/lib

notsocks:	
	$(CC) $(CFLAGS) $(SRCFILES) -o $(EXEC) -L$(STAGING_DIR)/usr/lib

static: $(SRCFILES)
	$(CC) $(CFLAGS) -static $(SRCFILES) -o $(EXEC) -L$(STAGING_DIR)/usr/lib/libtsocks.a

clean:
	rm -f $(OBJFILES) $(EXEC)

install: all
#	strip $(EXEC)
	test -d $(DESTDIR)$(CHROOT) || mkdir -p $(DESTDIR)$(CHROOT)
	test -d $(DESTDIR)/etc/ || mkdir -p $(DESTDIR)/etc/
	cp $(CONF) $(DESTDIR)/etc/$(CONF)
	cp $(TORTSOCKSCONF) $(DESTDIR)$(CHROOT)/tsocks.conf
	test -d $(DESTDIR)/usr/sbin/ || mkdir -p $(DESTDIR)/usr/sbin/
	cp $(EXEC) $(DESTDIR)/usr/sbin/
	test -d $(DESTDIR)/usr/share/man/man1/ || mkdir -p $(DESTDIR)/usr/share/man/man1/
	cp $(MANPAGE) $(DESTDIR)/usr/share/man/man1/
	test -d $(DESTDIR)/etc/init.d/ || mkdir -p $(DESTDIR)/etc/init.d/
	cp $(INITSCRIPT) $(DESTDIR)/etc/init.d/ttdnsd
	test -d $(DESTDIR)/usr/share/doc/ttdnsd || mkdir -p \
    $(DESTDIR)/usr/share/doc/ttdnsd/
	cp -r sample-configurations $(DESTDIR)/usr/share/doc/ttdnsd/
	test -d $(DESTDIR)/etc/default/ || mkdir -p $(DESTDIR)/etc/default/
	cp ttdnsd.defaults $(DESTDIR)/etc/default/ttdnsd

uninstall: all
	rm $(DESTDIR)/usr/sbin/$(EXEC)
	rm $(DESTDIR)/etc/$(CONF)
	rm -ri $(DESTDIR)$(CHROOT)
	rm $(DESTDIR)/usr/share/man/man1/$(MANPAGE)
	rm $(DESTDIR)/etc/init.d/ttdnsd
	rm -r $(DESTDIR)/$(DESTDIR)/usr/share/doc/ttdnsd

demo: install
	echo "Killing ttdnsd"
	-killall -9 ttdnsd
	echo "Starting ttdnsd"
	echo "Starting ttdnsd"
	TSOCKS_CONF_FILE=tsocks.conf ttdnsd -b 127.0.0.1 -p 53 \
    -P $(PIDFILE) -l
	echo "Attempting to lookup MX record for torproject.org through ttdnsd"
	dig @127.0.0.1 -t mx torproject.org

basic-dns-test: all
	-$(SUDO) killall -9 ttdnsd
	$(SUDO) sh -ec 'TSOCKS_CONF_FILE=tsocks.conf ./ttdnsd -l'
	dig @127.0.0.1 -t mx torproject.org

deb-src:
	dpkg-buildpackage -S -rfakeroot -us -uc -I.git -i.git

deb:
	dpkg-buildpackage -rfakeroot -us -uc -I.git -i.git

deb-clean:
	-rm build
	debian/rules clean

src-tar-gz: clean
	cd .. && mv ttdnsd ttdnsd-$(TTDNSDVERSION) && \
    tar --owner=nobody --group=nogroup --exclude=.gitignore \
    --exclude=.git \
    -cvzf ttdnsd-$(TTDNSDVERSION).tar.gz ttdnsd-$(TTDNSDVERSION) && mv \
    ttdnsd-$(TTDNSDVERSION) ttdnsd

signed-src: src-tar-gz
	gpg -u $(GPGKEYID) --use-agent -ab ../ttdnsd-$(TTDNSDVERSION).tar.gz

git-tag:
	git tag -u $(GPGKEYID) ttdnsd-$(TTDNSDVERSION)
	git push origin ttdnsd-$(TTDNSDVERSION)

# These all work; you've broken something if these fail
demo-dns-tests: demo
	dig @127.0.0.1 -x 38.229.70.10
	dig @127.0.0.1 -t A torproject.org
	dig @127.0.0.1 -t SOA torproject.org
	dig @127.0.0.1 -t NS torproject.org
	dig @127.0.0.1 -t MX torproject.org
	dig @127.0.0.1 -t CNAME svn.freehaven.net
	dig @127.0.0.1 -t srv _xmpp-client._tcp.google.com
	dig @127.0.0.1 -t aaaa www.kame.net
	dig @127.0.0.1 -t RRSIG nic.se

stress-test:
	dig @127.0.0.1 -x 38.229.70.10
	dig @127.0.0.1 -t A torproject.org
	dig @127.0.0.1 -t SOA torproject.org
	dig @127.0.0.1 -t NS torproject.org
	dig @127.0.0.1 -t MX torproject.org
	dig @127.0.0.1 -t CNAME svn.freehaven.net
	dig @127.0.0.1 -t srv _xmpp-client._tcp.google.com
	dig @127.0.0.1 -t aaaa www.kame.net
	dig @127.0.0.1 -t RRSIG nic.se

=== package/ttdnsd/Makefile ===
include $(TOPDIR)/rules.mk

PKG_NAME:=ttdnsd
PKG_VERSION:=0.7
PKG_RELEASE:=1
PKG_MD5SUM:=

PKG_SOURCE_URL:=http://www.mulliner.org/collin/feed/
PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
PKG_CAT:=zcat

PKG_BUILD_DIR:=$(BUILD_DIR)/$(PKG_NAME)-$(PKG_VERSION)
PKG_INSTALL_DIR:=$(PKG_BUILD_DIR)/ipkg-install

include $(TOPDIR)/package/rules.mk

$(eval $(call PKG_template,TTDNSD,ttdnsd,$(PKG_VERSION)-$(PKG_RELEASE),$(ARCH)))

$(PKG_BUILD_DIR)/.configured:
	touch $@

$(PKG_BUILD_DIR)/.built:
	rm -rf $(PKG_INSTALL_DIR)
	mkdir -p $(PKG_INSTALL_DIR)
	$(MAKE) -C $(PKG_BUILD_DIR) \
		CC=$(TARGET_CC) \
		CFLAGS="$(TARGET_CFLAGS)" \
		DESTDIR="$(PKG_INSTALL_DIR)" \
		STAGING_DIR="$(STAGING_DIR)" \
		all install
	touch $@

$(IPKG_TTDNSD):
	install -m0755 -d $(IDIR_TTDNSD)/usr/sbin
	install -m0755 -d $(IDIR_TTDNSD)/usr/lib
	$(CP) $(PKG_INSTALL_DIR)/ttdnsd $(IDIR_TTDNSD)/usr/sbin/
	$(CP) $(PKG_INSTALL_DIR)/libttdnstor.so.1 $(IDIR_TTDNSD)/usr/lib
	install -m0755 -d $(IDIR_TTDNSD)/etc
	$(CP) $(PKG_INSTALL_DIR)/ttdnsd.conf $(IDIR_TTDNSD)/etc
	$(RSTRIP) $(IDIR_TTDNSD)
	$(IPKG_BUILD) $(IDIR_TTDNSD) $(PACKAGE_DIR)

=== debian/changelog ===
ttdnsd (0.7) unstable; urgency=low

  * new upstream release

 -- Jacob Appelbaum <jacob@torproject.org>  Wed, 07 Jul 2010 00:41:22 -0700

ttdnsd (0.6) unstable; urgency=low

  * fix debian package dependencies
  * add unbound configuration file

 -- Jacob Appelbaum <jacob@torproject.org>  Fri, 02 Jul 2010 22:48:32 -0700

ttdnsd (0.5) unstable; urgency=low

  * Actual release to debian.torproject.org

 -- Jacob Appelbaum <jacob@torproject.org>  Fri, 02 Jul 2010 15:08:51 -0700

ttdnsd (0.4) unstable; urgency=low

  * Initial Release.

 -- Jacob Appelbaum <jacob@torproject.org>  Wed, 09 Jun 2010 00:41:55 +0200

=== debian/control ===
Source: ttdnsd
Section: comm
Priority: extra
Maintainer: Jacob Appelbaum <jacob@torproject.org>
Build-Depends: debhelper (>= 5), tsocks
Standards-Version: 3.8.4.0
Homepage: https://www.torproject.org/ttdnsd/

Package: ttdnsd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tor, tsocks, lsb-base (>= 3.0-6)
Description: Tor TCP DNS Daemon
 ttdnsd is a small UDP to TCP DNS shim for use with the Tor SOCKS proxy
 interface. It should also work with other SOCKS proxies.
 .
 ttdnsd requires  a  single  recursive  DNS  listener  on the open
 internet to be useful. It provides no DNS caching support and may be
 chained with unbound or another DNS caching program for performance
 reasons. By default ttdnsd ships with 8.8.8.8 as the open TCP DNS
 resolver.
 .
 ttdnsd creates a TCP connection through the configured
 SOCKS proxy to the randomly chosen DNS resolver(s) as
 configured in /etc/ttdns.conf  ;  the  connection  is
 held  open for a reasonable amount of time and
 subsequently closed when it is no longer in use. This
 allows users to make arbitrary DNS queries to will exit
 from the Tor network to the configured resolver(s).
 .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh  $@

override_dh_installinit:
	dh_installinit -o --init-script=ttdnsd
